diff -Nurd boost_1_36_0.orig/boost/detail/atomic_count_sync.hpp boost_1_36_0.arm/boost/detail/atomic_count_sync.hpp
--- boost_1_36_0.orig/boost/detail/atomic_count_sync.hpp	2007-11-23 12:03:14.000000000 -0500
+++ boost_1_36_0.arm/boost/detail/atomic_count_sync.hpp	2008-09-09 13:15:21.000000000 -0400
@@ -29,17 +29,46 @@
 
     void operator++()
     {
+#ifdef __ARM_ARCH_7A__
+       int v1, tmp;
+       asm volatile ("1:                 \n\t"
+                     "ldrex   %0, %1     \n\t"
+                     "add     %0 ,%0, #1 \n\t"
+                     "strex   %2, %0, %1 \n\t"
+                     "cmp     %2, #0     \n\t"
+                     "bne     1b         \n\t"
+                     : "=&r" (v1), "+Q"(value_), "=&r"(tmp)
+                    );
+#else
         __sync_add_and_fetch( &value_, 1 );
+#endif
     }
 
     long operator--()
     {
+#ifdef __ARM_ARCH_7A__
+       int v1, tmp;
+       asm volatile ("1:                 \n\t"
+                     "ldrex   %0, %1     \n\t"
+                     "sub     %0 ,%0, #1 \n\t"
+                     "strex   %2, %0, %1 \n\t"
+                     "cmp     %2, #0     \n\t"
+                     "bne     1b         \n\t"
+                     : "=&r" (v1), "+Q"(value_), "=&r"(tmp)
+                    );
+       return value_;
+#else
         return __sync_add_and_fetch( &value_, -1 );
+#endif
     }
 
     operator long() const
     {
+#if __ARM_ARCH_7A__
+        return value_;
+#else
         return __sync_fetch_and_add( &value_, 0 );
+#endif
     }
 
 private:
Binary files boost_1_36_0.orig/boost/detail/.atomic_count_sync.hpp.swp and boost_1_36_0.arm/boost/detail/.atomic_count_sync.hpp.swp differ
